<!DOCTYPE html>
<html>
    <head>
        <link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='styles.css') }}">
        <script type="text/javascript" src="{{ url_for('static', filename='functions.js') }}"></script>
        <H1 align="center">XChange - New Transaction</H1>
    </head>

    <body>
        <script>

            function calculateRate() {
                var key = '{{ config['FIXERIO_KEY'] }}';
                var url = '{{ config['FIXERIO_URL'] }}';

                var sell_obj = document.getElementById("sell_currency")
                var sell = sell_obj[sell_obj.selectedIndex].text;
                var buy_obj = document.getElementById("buy_currency")
                var buy = buy_obj[buy_obj.selectedIndex].text;

                if (sell == '--' || buy == '--') {
                    return
                }

                var xhr = new XMLHttpRequest();
                xhr.onreadystatechange = function() {
                    if (this.readyState == 4 && this.status == 200) {
                        var response = JSON.parse(this.responseText);
                        buy_rate = response['rates'][buy]
                        sell_rate = response['rates'][sell]
                        ratio = 1 / sell_rate 
                        buy_rate = ratio * buy_rate 
                        if (! isNaN(buy_rate)) {
                            document.getElementById("buy_ratio").value = buy_rate
                            updateAmount()
                        }
                    }
                };
                xhr.open("GET", url + "?access_key=" + key + "&symbols=" + sell + "," + buy, true);
                xhr.send()
            }

            function updateAmount() {
                var buy_rate = document.getElementById("buy_ratio").value
                var amount = document.getElementById("amount").value
                if (buy_rate && amount) {
                    buy_amount = buy_rate * amount
                    document.getElementById("buy_amount").value = numFormat(buy_amount)
                    document.getElementById("sell_amount_formatted").value = numFormat(Number(amount))
                }
            
            }
        </script>

        <br><br>
        <form id="tr_form" method="post">

        <table class="submit1" width="100%">
            <tr>
                <td>
                    <label for="sell_currency">Sell Currency:</label>
                </td>
                <td>
                </td>
                <td>
                    <label for="buy_ratio">Ratio:</label>
                </td>
                <td>
                </td>
                <td>
                    <label for="buy_currency">Buy Currency:</label>
                </td>
            </tr>
            <tr>
                <td>
                    <select id="sell_currency" onchange="calculateRate()" required>
                        <option disabled selected value>--</option>
                    {% for currency in currencies %}
                        <option value="{{ currency }}">{{ currency }}</option>
                    {% endfor %}
                    </select>
                </td>
                <td>
                    &rArr;
                </td>
                <td>
                    <input name="buy_ratio" id="buy_ratio" value="" disabled>
                </td>
                <td>
                    &rArr;
                </td>
                <td>
                    <select id="buy_currency" onchange="calculateRate()" required>
                        <option disabled selected value>--</option>
                    {% for currency in currencies %}
                        <option value="{{ currency }}">{{ currency }}</option>
                    {% endfor %}
                    </select>
                </td>
                <td>
            </tr>
        </table>
        <table class="submit2" width="100%">
            <tr>
                <td>
                    <table class="submit3">
                        <tr>
                            <td><label for="sell_amount">Sell amount:</label></td>
                            <td><input name="amount" id="amount" autocomplete="off" onkeyup="calculateRate()" required></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td><input name="sell_amount_formatted" id="sell_amount_formatted" value="" disabled></td>
                        </tr>
                    </table>
                </td>

                <td>
                    <table class="submit3">
                        <tr>
                            <td>
                                <label for="buy_amount">Buy amount:</label>
                                <input name="buy_amount" id="buy_amount" value="" disabled>
                                <div class=tooltip>?
                                    <span class=tooltiptext>
                                        decimal roundup will be applied on 8th digital precision
                                    </span>
                                </div>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td style="text-align: left; padding: 30px;">
                    <button onclick="window.location.href = '/xchange'">Back to main view</button>
                </td>
                <td id="submitbutton" style="text-align: right; padding: 30px;">
                    <input type=submit onclick>
                </td>
            </tr>
            <tr>
                <td  colspan=2 style="padding: 20px;">
                    <div id="result"></div>
                </td>
            </tr>
        </table>
        </form>


        <script>


function create_dropdown(select_id, datalist) {
    select = document.getElementById(select_id);
    for (var i = 0; i < datalist.length; i++) {
        var option = document.createElement("option");
        option.value = datalist[i].toString();
        option.textContent = datalist[i].toString();
        select.appendChild(option);
    };
}

window.addEventListener("load", function () {
    function sendData() {
        var XHR = new XMLHttpRequest();

        // Bind the FormData object and the form element
        var FD = new FormData(form);

        // Add selected options
        function addSelectedLabel(label, FD) {
            var choice = document.getElementById(label);
            var content = choice[choice.selectedIndex].text;
            FD.append(label, content);
        }

        addSelectedLabel("sell_currency", FD)    
        addSelectedLabel("buy_currency", FD)    

        // Define what happens in case of error
        XHR.addEventListener("error", function(event) {
            alert('Oops! Something went wrong.');
        });

        // Set up our request
        XHR.open("POST", "/api/xchange");

        // The data sent is what the user provided in the form
        XHR.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var resp = JSON.parse(this.responseText);
                    document.getElementById("result").innerHTML =
                        "<div class='success-msg'>" + "Transaction successful<br>" + 
                        numFormat(resp['sell_amount']) + " " + resp['sell_currency'] + " was exchanged to "
                        + numFormat(resp['buy_amount']) + " " + resp['buy_currency'] + "<br>" +
                        "on " + resp['date_booked'] + "</div>";
                    FD = new FormData
                } 
                if (this.readyState == 4 && this.status != 200) {
                    document.getElementById("result").innerHTML =
                        "<div class='error-msg'>Transaction couldn't be completed</div>";
                }
            }
        }
        XHR.send(FD);
    }

    // Access the form element...
    var form = document.getElementById("tr_form");

    // ...and take over its submit event.
    form.addEventListener("submit", function (event) {
        event.preventDefault();
        sendData();
        document.getElementById("tr_form").reset()
    });
});




        </script>
    </body>
</html>
